// Part of Measurement Kit <https://measurement-kit.github.io/>.
// Measurement Kit is free software under the BSD license. See AUTHORS
// and LICENSE for more information on the copying conditions.

#include "src/libmeasurement_kit/nettests/runnable.hpp"
#include "src/libmeasurement_kit/ooni/nettests.hpp"

namespace mk {
namespace nettests {

FacebookMessengerRunnable::FacebookMessengerRunnable() noexcept {
    test_name = "facebook_messenger";
    test_version = "0.0.2";
    needs_input = false;
}

void FacebookMessengerRunnable::main(std::string /*input*/, Settings options,
                            Callback<SharedPtr<nlohmann::json>> cb) {
    ooni::facebook_messenger(options, cb, reactor, logger);
}

} // namespace nettests
} // namespace mk
